'use strict';

var GM = Object.create(null);

GM.Controller = Object.freeze({
    "BANK_SELECT": 0,
    "MODULATION_WHEEL": 1,
    "BREATH_CONTROLLER": 2,
    "FOOT_CONTROLLER": 4,
    "PORTAMENTO_TIME": 5,
    "VOLUME": 7,
    "BALANCE": 8,
    "PAN": 10,
    "EXPRESSION": 11,
    "SUSTAIN_PEDAL": 64,
    "PORTAMENTO": 65,
    "SOSTENUTO": 66,
    "SOFT_PEDAL": 67,
    "LEGATO_FOOTSWITCH": 68,
    "SOUND_1_VARIATION": 70,
    "SOUND_2_TIMBRE_HARMONIC_INTENSITY": 71,
    "SOUND_3_RELEASE_TIME": 72,
    "SOUND_4_ATTACK_TIME": 73,
    "SOUND_5_BRIGHTNESS": 74,
    "SOUND_6_DECAY_TIME": 75,
    "SOUND_7_VIBRATO_RATE": 76,
    "SOUND_8_VIBRATO_DEPTH": 77,
    "SOUND_9_VIBRATO_DELAY": 78,
    "PORTAMENTO_CONTROL": 84,
    "EFFECT_1_DEPTH_REVERB": 91,
    "EFFECT_2_DEPTH_TREMOLO": 92,
    "EFFECT_3_DEPTH_CHORUS": 93,
    "RPN_LSB": 100,
    "RPN_MSB": 101,
    "ALL_SOUND_OFF": 120,
    "RESET_ALL_CONTROLLERS": 121,
    "ALL_NOTES_OFF": 123
});

GM.Instrument = Object.freeze({
    "ACOUSTIC_GRAND_PIANO": 0,
    "BRIGHT_ACOUSTIC_PIANO": 1,
    "ELECTRIC_GRAND_PIANO": 2,
    "HONKY-TONK_PIANO": 3,
    "RHODES_PIANO": 4,
    "ELECTRIC_PIANO": 5,
    "HARPSICHORD": 6,
    "CLAVINET": 7,
    "CELESTA": 8,
    "GLOCKENSPIEL": 9,
    "MUSIC_BOX": 10,
    "VIBRAPHONE": 11,
    "MARIMBA": 12,
    "XYLOPHONE": 13,
    "TUBULAR_BELLS": 14,
    "DULCIMER": 15,
    "DRAWBAR_ORGAN": 16,
    "PERCUSSIVE_ORGAN": 17,
    "ROCK_ORGAN": 18,
    "CHURCH_ORGAN": 19,
    "REED_ORGAN": 20,
    "ACCORDION": 21,
    "HARMONICA": 22,
    "TANGO_ACCORDION": 23,
    "ACOUSTIC_GUITAR_NYLON": 24,
    "ACOUSTIC_GUITAR_STEEL": 25,
    "ELECTRIC_GUITAR_JAZZ": 26,
    "ELECTRIC_GUITAR_CLEAN": 27,
    "ELECTRIC_GUITAR_MUTED": 28,
    "OVERDRIVEN_GUITAR": 29,
    "DISTORTION_GUITAR": 30,
    "GUITAR_HARMONICS": 31,
    "ACOUSTIC_BASS": 32,
    "ELECTRIC_BASS_FINGER": 33,
    "ELECTRIC_BASS_PICK": 34,
    "FRETLESS_BASS": 35,
    "SLAP_BASS_1": 36,
    "SLAP_BASS_2": 37,
    "SYNTH_BASS_1": 38,
    "SYNTH_BASS_2": 39,
    "VIOLIN": 40,
    "VIOLA": 41,
    "CELLO": 42,
    "CONTRABASS": 43,
    "TREMOLO_STRINGS": 44,
    "PIZZICATO_STRINGS": 45,
    "ORCHESTRAL_HARP": 46,
    "TIMPANI": 47,
    "STRING_ENSEMBLE_1": 48,
    "STRING_ENSEMBLE_2": 49,
    "SYNTH_STRINGS_1": 50,
    "SYNTH_STRINGS_2": 51,
    "CHOIR_AAHS": 52,
    "VOICE_OOHS": 53,
    "SYNTH_CHOIR": 54,
    "ORCHESTRA_HIT": 55,
    "TRUMPET": 56,
    "TROMBONE": 57,
    "TUBA": 58,
    "MUTED_TRUMPET": 59,
    "FRENCH_HORN": 60,
    "BRASS_SECTION": 61,
    "SYNTH_BRASS_1": 62,
    "SYNTH_BRASS_2": 63,
    "SOPRANO_SAX": 64,
    "ALTO_SAX": 65,
    "TENOR_SAX": 66,
    "BARITONE_SAX": 67,
    "OBOE": 68,
    "ENGLISH_HORN": 69,
    "BASSOON": 70,
    "CLARINET": 71,
    "PICCOLO": 72,
    "FLUTE": 73,
    "RECORDER": 74,
    "PAN_FLUTE": 75,
    "BLOWN_BOTTLE": 76,
    "SHAKUHACHI": 77,
    "WHISTLE": 78,
    "OCARINA": 79,
    "LEAD_1_SQUARE": 80,
    "LEAD_2_SAWTOOTH": 81,
    "LEAD_3_CALLIOPE": 82,
    "LEAD_4_CHIFF": 83,
    "LEAD_5_CHARANG": 84,
    "LEAD_6_VOICE": 85,
    "LEAD_7_FIFTHS": 86,
    "LEAD_8_BASS_LEAD": 87,
    "PAD_1_NEW_AGE": 88,
    "PAD_2_WARM": 89,
    "PAD_3_POLYSYNTH": 90,
    "PAD_4_CHOIR": 91,
    "PAD_5_BOWED": 92,
    "PAD_6_METALLIC": 93,
    "PAD_7_HALO": 94,
    "PAD_8_SWEEP": 95,
    "FX_1_RAIN": 96,
    "FX_2_SOUNDTRACK": 97,
    "FX_3_CRYSTAL": 98,
    "FX_4_ATMOSPHERE": 99,
    "FX_5_BRIGHTNESS": 100,
    "FX_6_GOBLINS": 101,
    "FX_7_ECHOES": 102,
    "FX_8_SCI-FI": 103,
    "SITAR": 104,
    "BANJO": 105,
    "SHAMISEN": 106,
    "KOTO": 107,
    "KALIMBA": 108,
    "BAGPIPE": 109,
    "FIDDLE": 110,
    "SHANAI": 111,
    "TINKLE_BELL": 112,
    "AGOGO": 113,
    "STEEL_DRUMS": 114,
    "WOODBLOCK": 115,
    "TAIKO_DRUM": 116,
    "MELODIC_TOM": 117,
    "SYNTH_DRUM": 118,
    "REVERSE_CYMBAL": 119,
    "GUITAR_FRET_NOISE": 120,
    "BREATH_NOISE": 121,
    "SEASHORE": 122,
    "BIRD_TWEET": 123,
    "TELEPHONE_RING": 124,
    "HELICOPTER": 125,
    "APPLAUSE": 126,
    "GUNSHOT": 127
});

GM.Percussion = Object.freeze({
    "BASS_DRUM_2": 35,
    "BASS_DRUM_1": 36,
    "SIDE_STICK": 37,
    "SNARE_DRUM_1": 38,
    "HAND_CLAP": 39,
    "SNARE_DRUM_2": 40,
    "LOW_TOM_2": 41,
    "CLOSED_HI-HAT": 42,
    "LOW_TOM_1": 43,
    "PEDAL_HI-HAT": 44,
    "MID_TOM_2": 45,
    "OPEN_HI-HAT": 46,
    "MID_TOM_1": 47,
    "HIGH_TOM_2": 48,
    "CRASH_CYMBAL_1": 49,
    "HIGH_TOM_1": 50,
    "RIDE_CYMBAL_1": 51,
    "CHINESE_CYMBAL": 52,
    "RIDE_BELL": 53,
    "TAMBOURINE": 54,
    "SPLASH_CYMBAL": 55,
    "COWBELL": 56,
    "CRASH_CYMBAL_2": 57,
    "VIBRA_SLAP": 58,
    "RIDE_CYMBAL_2": 59,
    "HIGH_BONGO": 60,
    "LOW_BONGO": 61,
    "MUTE_HIGH_CONGA": 62,
    "OPEN_HIGH_CONGA": 63,
    "LOW_CONGA": 64,
    "HIGH_TIMBALE": 65,
    "LOW_TIMBALE": 66,
    "HIGH_AGOGO": 67,
    "LOW_AGOGO": 68,
    "CABASA": 69,
    "MARACAS": 70,
    "SHORT_WHISTLE": 71,
    "LONG_WHISTLE": 72,
    "SHORT_GUIRO": 73,
    "LONG_GUIRO": 74,
    "CLAVES": 75,
    "HIGH_WOOD_BLOCK": 76,
    "LOW_WOOD_BLOCK": 77,
    "MUTE_CUICA": 78,
    "OPEN_CUICA": 79,
    "MUTE_TRIANGLE": 80,
    "OPEN_TRIANGLE": 81
});

module.exports = GM;